Botan 1.10.17

Public Types | Public Member Functions | List of all members
Botan::CAST_256 Class Reference

`#include <cast256.h>`

Inheritance diagram for Botan::CAST_256:

## Public Types
enum |

## Public Member Functions
size_t | block_size () const
| CAST_256 ()
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
virtual size_t | parallelism () const
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const

## Detailed Description

CAST-256

Definition at line 18 of file cast256.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| inherited

Definition at line 107 of file block_cipher.h.

107 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:107

## Constructor & Destructor Documentation

## ◆ CAST_256()

Botan::CAST_256::CAST_256 | ( |  | ) |
| inline

Definition at line 28 of file cast256.h.

28 : MK(48), RK(48) {}

## Member Function Documentation

## ◆ block_size()

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::block_size | ( |  | ) | const
| inline virtual inherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 108 of file block_cipher.h.

108 { return BS; }

## ◆ clear()

void Botan::CAST_256::clear | ( |  | ) |
| inline virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 24 of file cast256.h.

References Botan::zeroise().

24 { zeroise(MK); zeroise(RK); }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428

## ◆ clone()

BlockCipher* Botan::CAST_256::clone | ( |  | ) | const
| inline virtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 26 of file cast256.h.

26 { return new CAST_256; }
Botan::CAST_256::CAST_256
CAST_256()
Definition: cast256.h:28

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inline inherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::CAST_256::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 95 of file cast256.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE, Botan::load_be< u32bit >(), and Botan::store_be().

96 {
97 for(size_t i = 0; i != blocks; ++i)
98 {
99 u32bit A = load_be<u32bit>(in, 0);
100 u32bit B = load_be<u32bit>(in, 1);
101 u32bit C = load_be<u32bit>(in, 2);
102 u32bit D = load_be<u32bit>(in, 3);
103
104 round1(C, D, MK[44], RK[44]); round2(B, C, MK[45], RK[45]);
105 round3(A, B, MK[46], RK[46]); round1(D, A, MK[47], RK[47]);
106 round1(C, D, MK[40], RK[40]); round2(B, C, MK[41], RK[41]);
107 round3(A, B, MK[42], RK[42]); round1(D, A, MK[43], RK[43]);
108 round1(C, D, MK[36], RK[36]); round2(B, C, MK[37], RK[37]);
109 round3(A, B, MK[38], RK[38]); round1(D, A, MK[39], RK[39]);
110 round1(C, D, MK[32], RK[32]); round2(B, C, MK[33], RK[33]);
111 round3(A, B, MK[34], RK[34]); round1(D, A, MK[35], RK[35]);
112 round1(C, D, MK[28], RK[28]); round2(B, C, MK[29], RK[29]);
113 round3(A, B, MK[30], RK[30]); round1(D, A, MK[31], RK[31]);
114 round1(C, D, MK[24], RK[24]); round2(B, C, MK[25], RK[25]);
115 round3(A, B, MK[26], RK[26]); round1(D, A, MK[27], RK[27]);
116 round1(D, A, MK[23], RK[23]); round3(A, B, MK[22], RK[22]);
117 round2(B, C, MK[21], RK[21]); round1(C, D, MK[20], RK[20]);
118 round1(D, A, MK[19], RK[19]); round3(A, B, MK[18], RK[18]);
119 round2(B, C, MK[17], RK[17]); round1(C, D, MK[16], RK[16]);
120 round1(D, A, MK[15], RK[15]); round3(A, B, MK[14], RK[14]);
121 round2(B, C, MK[13], RK[13]); round1(C, D, MK[12], RK[12]);
122 round1(D, A, MK[11], RK[11]); round3(A, B, MK[10], RK[10]);
123 round2(B, C, MK[ 9], RK[ 9]); round1(C, D, MK[ 8], RK[ 8]);
124 round1(D, A, MK[ 7], RK[ 7]); round3(A, B, MK[ 6], RK[ 6]);
125 round2(B, C, MK[ 5], RK[ 5]); round1(C, D, MK[ 4], RK[ 4]);
126 round1(D, A, MK[ 3], RK[ 3]); round3(A, B, MK[ 2], RK[ 2]);
127 round2(B, C, MK[ 1], RK[ 1]); round1(C, D, MK[ 0], RK[ 0]);
128
129 store_be(out, A, B, C, D);
130
131 in += BLOCK_SIZE;
132 out += BLOCK_SIZE;
133 }
134 }
Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::load_be< u32bit >
u32bit load_be< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:166
Botan::store_be
void store_be(u16bit in, byte out[2])
Definition: loadstor.h:412
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::OFB::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inline inherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::CAST_256::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 51 of file cast256.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE, Botan::load_be< u32bit >(), and Botan::store_be().

52 {
53 for(size_t i = 0; i != blocks; ++i)
54 {
55 u32bit A = load_be<u32bit>(in, 0);
56 u32bit B = load_be<u32bit>(in, 1);
57 u32bit C = load_be<u32bit>(in, 2);
58 u32bit D = load_be<u32bit>(in, 3);
59
60 round1(C, D, MK[ 0], RK[ 0]); round2(B, C, MK[ 1], RK[ 1]);
61 round3(A, B, MK[ 2], RK[ 2]); round1(D, A, MK[ 3], RK[ 3]);
62 round1(C, D, MK[ 4], RK[ 4]); round2(B, C, MK[ 5], RK[ 5]);
63 round3(A, B, MK[ 6], RK[ 6]); round1(D, A, MK[ 7], RK[ 7]);
64 round1(C, D, MK[ 8], RK[ 8]); round2(B, C, MK[ 9], RK[ 9]);
65 round3(A, B, MK[10], RK[10]); round1(D, A, MK[11], RK[11]);
66 round1(C, D, MK[12], RK[12]); round2(B, C, MK[13], RK[13]);
67 round3(A, B, MK[14], RK[14]); round1(D, A, MK[15], RK[15]);
68 round1(C, D, MK[16], RK[16]); round2(B, C, MK[17], RK[17]);
69 round3(A, B, MK[18], RK[18]); round1(D, A, MK[19], RK[19]);
70 round1(C, D, MK[20], RK[20]); round2(B, C, MK[21], RK[21]);
71 round3(A, B, MK[22], RK[22]); round1(D, A, MK[23], RK[23]);
72 round1(D, A, MK[27], RK[27]); round3(A, B, MK[26], RK[26]);
73 round2(B, C, MK[25], RK[25]); round1(C, D, MK[24], RK[24]);
74 round1(D, A, MK[31], RK[31]); round3(A, B, MK[30], RK[30]);
75 round2(B, C, MK[29], RK[29]); round1(C, D, MK[28], RK[28]);
76 round1(D, A, MK[35], RK[35]); round3(A, B, MK[34], RK[34]);
77 round2(B, C, MK[33], RK[33]); round1(C, D, MK[32], RK[32]);
78 round1(D, A, MK[39], RK[39]); round3(A, B, MK[38], RK[38]);
79 round2(B, C, MK[37], RK[37]); round1(C, D, MK[36], RK[36]);
80 round1(D, A, MK[43], RK[43]); round3(A, B, MK[42], RK[42]);
81 round2(B, C, MK[41], RK[41]); round1(C, D, MK[40], RK[40]);
82 round1(D, A, MK[47], RK[47]); round3(A, B, MK[46], RK[46]);
83 round2(B, C, MK[45], RK[45]); round1(C, D, MK[44], RK[44]);
84
85 store_be(out, A, B, C, D);
86
87 in += BLOCK_SIZE;
88 out += BLOCK_SIZE;
89 }
90 }
Botan::Block_Cipher_Fixed_Params< 16, 4, 32, 4 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::load_be< u32bit >
u32bit load_be< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:166
Botan::store_be
void store_be(u16bit in, byte out[2])
Definition: loadstor.h:412
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ key_spec()

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::key_spec | ( |  | ) | const
| inline virtual inherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 110 of file block_cipher.h.

111 {
112 return Key_Length_Specification(KMIN, KMAX, KMOD);
113 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::CAST_256::name | ( |  | ) | const
| inline virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 25 of file cast256.h.

25 { return "CAST-256"; }

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inline inherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inline virtual inherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::AES_256_NI, Botan::AES_192_NI, Botan::AES_128_NI, Botan::IDEA_SSE2, Botan::Noekeon_SIMD, Botan::Serpent_SIMD, and Botan::XTEA_SIMD.

Definition at line 30 of file block_cipher.h.

30 { return 1; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), and Botan::StreamCipher_Filter::StreamCipher_Filter().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), and Botan::Lion::Lion().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/cast/cast256.h
- src/block/cast/cast256.cpp
- src/block/cast/cast_tab.cpp